// ExtView.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include <io.h>
#include <direct.h>
#include <sys/stat.h>
#pragma warning (disable : 4786)
#include <set>
#include <string>
using namespace std;

void AddExt(set<string>& st,const char* fnam)
{
	const char* p = strrchr(fnam,'.');
	st.insert(p ? p+1 : "(null)");
}

void SetExt(set<string>& st,string fnam)
{
	struct stat	stt;
	if (stat(fnam.c_str(),&stt)) return;
	if (!(stt.st_mode & _S_IFDIR)) {
		AddExt(st,fnam.c_str());
		return;
	}
	_finddata_t	fd;
	long		h;
	if ((h = _findfirst((fnam + "\\*.*").c_str(),&fd)) != -1L) {
		do {
			if (!strcmp(fd.name,".") || !strcmp(fd.name,".."))
				continue;
			SetExt(st,fnam + "\\" + fd.name);
		} while (_findnext(h,&fd) == 0);
		_findclose(h);
	}
}

namespace ClipBoardText {
	bool Set(const char* p0){
		if (!OpenClipboard(0)) return false;
		if (!EmptyClipboard()) return false;
		HGLOBAL	p = GlobalAlloc(GHND | GMEM_DDESHARE,strlen(p0)+1);
		char* q = (char*)GlobalLock(p);
		strcpy(q,p0);
		GlobalUnlock(p);
		if (!SetClipboardData(CF_TEXT,q)) {
			GlobalFree(p);
			CloseClipboard();
			return false;
		}
		CloseClipboard();
		return true;
	}
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	set<string>		st;
	char	*q, *p = lpCmdLine;
	while (*p) {
		if (*p == '"') {
			q = strchr(p+1,'"');
			if (!q) break;
			SetExt(st,string(p+1,q).c_str());
			p = q+1;
			if (*p) ++p;
		} else {
			q = strchr(p+1,' ');
			SetExt(st,q ? string(p,q).c_str() : p);
			if (!q) break;
			p = q+1;
		}
	}
	string	s;
	set<string>::iterator	it;
	for (it=st.begin();it!=st.end();++it)
		s += *it + "\n";
	if (s.empty()) s = "Drag files";
	ClipBoardText::Set(s.c_str());
	MessageBox(0,s.c_str(),"ExtView",MB_OK);
	return 0;
}

